Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/main.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/main.cpp	(revision 2127)
@@ -8,10 +8,10 @@
 
 Camera *cameras = NULL;
-GLuint numCameras = 0;
+int numCameras = 0;
 
 Color *colors = NULL;
 
-GLuint **histogram = NULL,
-        *queries = NULL;
+int **histogram = NULL;
+GLuint *queries = NULL;
 
 Mesh *mesh = NULL;
@@ -28,5 +28,5 @@
           bRemoveRedundantVertices = GL_TRUE;
 
-GLuint cameraType = 0,
+int cameraType = 0,
        numDemandedTriangles = 0;
 
@@ -174,4 +174,19 @@
 }
 
+void VMI::updateHWAcceleration(Change *c) {
+   
+#ifdef VERTEX_ARRAY_INTERLEAVE
+    if (interleave != NULL) free(interleave);
+    interleave = setupInterleave(mesh, colors);
+#endif
+#ifdef VERTEX_ARRAY
+    updateVertexArray(mesh, c);
+#endif
+#ifdef VERTEX_BUFFER_OBJECTS
+    updateVertexBufferObjects(mesh, c);
+#endif
+
+}
+
 void VMI::setOrthographicProjection(void) {
     // Switch to projection mode
@@ -208,5 +223,5 @@
 void VMI::renderGeometry(void) {
 #ifdef IMMEDIATE_MODE
-    GLuint i, v1, v2, v3;
+    int i, v1, v2, v3;
 
     // Immediate mode
@@ -228,5 +243,5 @@
 #else
 #ifdef VERTEX_ARRAY
-    glDrawArrays(GL_TRIANGLES, 0, mesh->currentNumTriangles * 3);
+    glDrawArrays(GL_TRIANGLES, 0, mesh->numTriangles * 3);
 #endif
 #ifdef VERTEX_ARRAY_INTERLEAVE
@@ -235,5 +250,5 @@
 #endif
 #ifdef VERTEX_BUFFER_OBJECTS
-    glDrawArrays(GL_TRIANGLES, 0, mesh->currentNumTriangles * 3);
+    glDrawArrays(GL_TRIANGLES, 0, mesh->numTriangles * 3);
 #endif
 
@@ -264,16 +279,22 @@
     glutSwapBuffers();
 }
-void VMI::renderScene(GLuint **histogram, GLuint numCameras)
-{
-    GLuint i;
+
+void VMI::resetProjectedAreas(int **histogram, int numCameras) {
+    int i = 0;
+
+    // Reset the projected areas for all cameras
+    for (i=0; i<numCameras; i++)
+        resetSWHistogram(histogram[i], mesh->numTriangles);
+}
+
+void VMI::getProjectedAreas(int **histogram, int numCameras)
+{
+    int i;
 
     // draw to the frame buffer
     glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);
-        
-    // Apply HW acceleration OpenGL Technique
-    applyHWAcceleration(); 
-
-    glDrawBuffer(GL_BACK);
-    glReadBuffer(GL_BACK);
+
+    //glDrawBuffer(GL_BACK);
+    //glReadBuffer(GL_BACK);
 
     // Get the projected areas for all cameras
@@ -312,7 +333,7 @@
     ///////////////////////////////////////////////////////////////////////////
 }
-void VMI::renderSceneWin(GLuint **histogram, GLuint numCameras, Change *c)
-{
-    GLuint i, j, t, background;
+void VMI::getProjectedAreasWin(int **histogram, int numCameras, Change *c)
+{
+    int i, j, t, background;
     int del_area, mod_area;
     GLfloat min[3], max[3];
@@ -325,9 +346,9 @@
     //printf("\n(%f,%f,%f)-(%f,%f,%f)\n", min[0], min[1], min[2], max[0], max[1], max[2]);
     
-    // Apply HW acceleration OpenGL Technique
-    applyHWAcceleration(); 
-
-    glDrawBuffer(GL_BACK);
-    glReadBuffer(GL_BACK);
+    // Update HW acceleration OpenGL Technique
+    updateHWAcceleration(c);
+
+    //glDrawBuffer(GL_BACK);
+    //glReadBuffer(GL_BACK);
 
     // Get the projected areas for all cameras
@@ -355,5 +376,5 @@
         mod_area = 0;
 
-        for (j=0; j<( GLuint)c->numDel; j++) {
+        for (j=0; j<c->numDel; j++) {
             t = c->deleted[j].id;
             del_area += histogram[i][t + 1];
@@ -362,5 +383,5 @@
         }
 
-        for (j=0; j<( GLuint)c->numMod; j++) {
+        for (j=0; j<c->numMod; j++) {
             t = c->modified[j].id;
             del_area += histogram[i][t + 1];
@@ -371,5 +392,5 @@
         getSWHistogramWin(histogram[i], pixels, min, max, c); 
 
-        for (j=0; j<( GLuint)c->numMod; j++) {
+        for (j=0; j<c->numMod; j++) {
             t = c->modified[j].id;
             mod_area += histogram[i][t + 1];
@@ -425,4 +446,18 @@
     
     glDeleteBuffersARB(1, &color_buf);
+
+    //free(pbuf_vertices);
+    //free(pbuf_colors);
+
+		buf_vertices = NULL;
+    buf_colors = NULL;
+
+#endif
+#ifdef VERTEX_ARRAY
+    //free(pbuf_vertices);
+    //free(pbuf_colors);
+
+		buf_vertices = NULL;
+    buf_colors = NULL;
 #endif
 
@@ -457,4 +492,7 @@
 
 	start = clock();
+
+	// Apply HW acceleration OpenGL Technique
+  applyHWAcceleration();
 
 	getProjectedAreas(histogram, numCameras);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/change.cpp	(revision 2127)
@@ -157,6 +157,6 @@
   if (c->numMod > 0) {
       mesh->vertices[c->v].triangles = 
-          (GLuint *)realloc(mesh->vertices[c->v].triangles, 
-          (mesh->vertices[c->v].numTriangles + mesh->vertices[c->u].numTriangles) * sizeof(GLuint));
+          (int *)realloc(mesh->vertices[c->v].triangles, 
+          (mesh->vertices[c->v].numTriangles + mesh->vertices[c->u].numTriangles) * sizeof(int));
   }
 
@@ -193,39 +193,4 @@
 }
 
-int VMI::hasEdge(Triangle *t, int e) {
-    int e0 = t->edges[0],
-        e1 = t->edges[1],
-        e2 = t->edges[2];
-    
-    if ((e == e0) || (e == e1) || (e == e2)) return TRUE;
-
-    return FALSE;
-}
-
-void VMI::getEdges(Triangle *t, Change *c, int *l, int *r) {
-
-    // Default edges
-    *l = -1;
-    *r = -1;
-
-    // Set edge l and r
-    if ((int)t->edges[0] == c->e) {
-        *l = t->edges[1];
-        *r = t->edges[2];
-        if ((int)mesh->edges[*l].u == c->v || (int)mesh->edges[*l].v == c->v)
-            swap(l, r);
-    } else if ((int)t->edges[1] == c->e) {
-        *l = t->edges[0];
-        *r = t->edges[2];
-        if ((int)mesh->edges[*l].u == c->v || (int)mesh->edges[*l].v == c->v)
-            swap(l, r);
-    } else if ((int)t->edges[2] == c->e) {
-        *l = t->edges[0];
-        *r = t->edges[1];
-        if ((int)mesh->edges[*l].u == c->v || (int)mesh->edges[*l].v == c->v)
-            swap(l, r);
-    }
-}
-
 void VMI::swap(int *i, int *j) {
     int t;
@@ -238,8 +203,5 @@
 void VMI::deleteTriangles(Mesh *mesh, Change *c)
 {
-	    int i, j, t, v;
-#ifdef USE_EDGE_ADJACENCY
-    int t1, l, r;
-#endif
+	  int i, j, t, v;
     
     for (i=0; i<c->numDel; i++) {
@@ -255,26 +217,4 @@
         }
 
-#ifdef USE_EDGE_ADJACENCY
-        // Update triangle edge adjancency
-        // The modified triangles have to be calculated before
-        // Set edge l and r
-        getEdges(&c->deleted[i], c, &l, &r);
-        //printf("e%d(%d,%d): l:%d r:%d\n", c->e, c->u, c->v, l, r);
-        // Find triangle that contains edge l
-        for (j=0; j<c->numMod; j++)
-            if (hasEdge(&c->modified[j], l)) {
-                // Change edge l by r in the Mesh
-                t1 = c->modified[j].id;
-                //printf("t:%d %d %d %d\n", t1, mesh->triangles[t1].edges[0], mesh->triangles[t1].edges[1] ,mesh->triangles[t1].edges[2]);
-                if (mesh->triangles[t1].edges[0] == (GLuint)l) mesh->triangles[t1].edges[0] = r;
-                if (mesh->triangles[t1].edges[1] == (GLuint)l) mesh->triangles[t1].edges[1] = r;
-                if (mesh->triangles[t1].edges[2] == (GLuint)l) mesh->triangles[t1].edges[2] = r;
-                //printf("t:%d %d %d %d\n", t1, mesh->triangles[t1].edges[0], mesh->triangles[t1].edges[1] ,mesh->triangles[t1].edges[2]);
-                break;
-            }
-
-        // Delete edge l
-        if (l != -1) mesh->edges[l].enable = FALSE;
-#endif
         mesh->triangles[t].enable = FALSE;
         mesh->currentNumTriangles--;
@@ -301,10 +241,5 @@
             addItem((int *)mesh->vertices[v].triangles,(int *)&mesh->vertices[v].numTriangles,t);
         }
-#ifdef USE_EDGE_ADJACENCY
-        // Enable adjacent edges
-        for (j=0; j<3; j++) {
-            mesh->edges[mesh->triangles[t].edges[j]].enable = TRUE;
-        }
-#endif
+
         mesh->triangles[t].enable = TRUE;
         mesh->currentNumTriangles++;
@@ -312,5 +247,5 @@
 }
 
-Triangle *VMI::getTrianglesToModify(Mesh *mesh, Change *c, GLuint *numMod) {
+Triangle *VMI::getTrianglesToModify(Mesh *mesh, Change *c, int *numMod) {
   int i, t;
   Triangle *modified = NULL;
@@ -336,5 +271,5 @@
 }
 
-Triangle *VMI::getTrianglesToDelete(Mesh *mesh, Change *c, GLuint *numDel) {
+Triangle *VMI::getTrianglesToDelete(Mesh *mesh, Change *c, int *numDel) {
   int i, t;
   Triangle *deleted = NULL;
@@ -359,96 +294,69 @@
 }
 
-void VMI::deleteEdges(Mesh *mesh, Change *c) {
+void VMI::modifyEdges(Mesh *mesh, Change *c) {
     int i, e;
-#ifndef USE_EDGE_ADJACENCY
-    int n0, n1, n2;
-#else
-    int j, u, v;
-#endif
-
-#ifdef USE_EDGE_ADJACENCY
-    for (i=0; i<c->numDel; i++) {
+
+	for(i = 0; i < mesh->vertices[c->v].numEdges; i++) {
         
-        for (j=0; j<3; j++) {
-            e = c->deleted[i].edges[j];
-            if (e != c->e) {
-                u = mesh->edges[e].u;
-                v = mesh->edges[e].v;
-                if (u == c->u || v == c->u) {
-                    //printf("%d\n",j);
-                    mesh->edges[e].enable = FALSE;
-                }
-            }
-        }
-        //getchar();
-    }
-#else
-    for (i=0; i<c->numDel; i++) {
-
-        n0 = c->deleted[i].indices[0];
-        n1 = c->deleted[i].indices[1];
-        n2 = c->deleted[i].indices[2];
-
-        if ((n0 == c->u && n1 != c->v) || (n1 == c->u && n0 != c->v)) {
-            e = findEdge(mesh->edges, mesh->numEdges, n0, n1);
-
-            //printf("a\n");
-            if (e != -1)
-                mesh->edges[e].enable = FALSE;
-        }
-
-        if ((n1 == c->u && n2 != c->v) || (n2 == c->u && n1 != c->v)) {
-            e = findEdge(mesh->edges, mesh->numEdges, n1, n2);
-            
-            //printf("b\n");
-            if (e != -1)
-                mesh->edges[e].enable = FALSE;
-        }
-
-        if ((n0 == c->u && n2 != c->v) || (n2 == c->u && n0 != c->v)) {
-            e = findEdge(mesh->edges, mesh->numEdges, n0, n2);
-            
-            //printf("c\n");
-            if (e != -1)
-                mesh->edges[e].enable = FALSE;
-        }
-        //getchar();
-    }
-#endif
-}
-
-void VMI::modifyEdges(Mesh *mesh, Change *c) {
-    int e, u, v;
-    
-    // Update mesh and heap
-    for(e = 0; e < (int)mesh->numEdges; e++) {
-        
+		e = mesh->vertices[c->v].edges[i];
+
         if (mesh->edges[e].enable == TRUE) {
             
             // Modify edge
-            if ((int)mesh->edges[e].u == c->u)
+            if (mesh->edges[e].u == c->u)
                 mesh->edges[e].u = c->v;
             
-            if ((int)mesh->edges[e].v == c->u)
+            if (mesh->edges[e].v == c->u)
                 mesh->edges[e].v = c->v;
-            
-            // Check edge
-            u = mesh->edges[e].u;
-            v = mesh->edges[e].v;
-            
-            // if the edge is not valid, we simply delete it
-            if ((u == v) || 
-                (u == c->u) || (v == c->u)) 
-                
-                mesh->edges[e].enable = FALSE;
         }
     }
 }
 
+int VMI::find(int *edges, int num, int v_) {
+	int i;
+
+	int u, v;
+
+
+	for(i=0; i<num; i++) {
+
+		u = mesh->edges[edges[i]].u;
+
+		v = mesh->edges[edges[i]].v;
+
+		if (u == v_ || v == v_) return TRUE;
+
+	}
+
+	return FALSE;
+}
+void VMI::updateEdgeAdj(Mesh *mesh, Change *c) {
+	int i;
+
+	int v, e;
+
+	mesh->vertices[c->v].edges = 
+            (int *)realloc(mesh->vertices[c->v].edges, 
+            (mesh->vertices[c->v].numEdges + mesh->vertices[c->u].numEdges) * sizeof(int));
+
+	for (i=0; i<mesh->vertices[c->u].numEdges; i++) {
+        
+		e = mesh->vertices[c->u].edges[i];
+		if (mesh->edges[e].u == c->u) v =mesh->edges[e].v;
+		else v = mesh->edges[e].u;
+		
+		if (!find(mesh->vertices[c->v].edges, mesh->vertices[c->v].numEdges, v))
+			addItem(mesh->vertices[c->v].edges, &mesh->vertices[c->v].numEdges, e);
+		else mesh->edges[e].enable = FALSE;
+	}
+
+	delItem(mesh->vertices[c->v].edges, &mesh->vertices[c->v].numEdges, c->e);
+}
+
 ///////////////////////////////////////////////////////////////////////////////
 
 // Compute the triangle mesh changes due to a heap node simplification
 void VMI::computeChange(Mesh *mesh, Change *c) {
-  GLuint numMod, numDel;
+  int numMod, numDel;
   Triangle *m = getTrianglesToModify(mesh, c, &numMod),
             *d = getTrianglesToDelete(mesh, c, &numDel);
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/camera.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/camera.cpp	(revision 2090)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/camera.cpp	(revision 2127)
@@ -14,8 +14,8 @@
 //#define DRAW_DEBUG // just for debugging not necessary
 
-Camera *VMI::loadCameras(GLdouble radius, char* filename, GLuint *numCameras) {
+Camera *VMI::loadCameras(GLdouble radius, char* filename, int *numCameras) {
     FILE *fp;
     Camera *cameras;
-    GLuint num, i;
+    int num, i;
     GLfloat eyeX, eyeY, eyeZ,
         centerX, centerY, centerZ,
@@ -118,7 +118,7 @@
 }
 
-void VMI::saveCameras(char* filename, Camera *cameras, GLuint numCameras) {
+void VMI::saveCameras(char* filename, Camera *cameras, int numCameras) {
     FILE *fp;
-    GLuint i;
+    int i;
 
     if((fp= fopen(filename, "wt"))== NULL) {
@@ -170,5 +170,5 @@
 }
 
-Camera *VMI::setCameras(GLdouble radius, GLuint type, GLuint *numCameras) {
+Camera *VMI::setCameras(GLdouble radius, int type, int *numCameras) {
     Camera *cameras = NULL;
 
@@ -221,6 +221,6 @@
 }
 
-void VMI::setCameraWeights(Camera *cameras, GLuint numCameras, GLdouble *weights) {
-    GLuint i;
+void VMI::setCameraWeights(Camera *cameras, int numCameras, GLdouble *weights) {
+    int i;
 
     for (i = 0; i<numCameras; i++) {
@@ -229,6 +229,6 @@
 }
 
-void VMI::printCameras(Camera *cameras, GLuint numCameras) {
-    GLuint i;
+void VMI::printCameras(Camera *cameras, int numCameras) {
+    int i;
     
     printf("\n");
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/buffers.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/buffers.cpp	(revision 2127)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/buffers.cpp	(revision 2127)
@@ -0,0 +1,528 @@
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "../include/GL/glew.h"
+
+#include "../include/buffers.h"
+#include "../include/global.h"
+
+namespace	VMI
+{
+Vertex_ *buf_vertices = NULL;
+Color   *buf_colors = NULL;
+
+Vertex_ *pbuf_vertices;
+Color   *pbuf_colors;
+
+GLuint vertex_buf = 0,
+       color_buf = 0;
+
+}
+
+using namespace	VMI;
+
+void VMI::saveVertexBuffer(Change *c, VertexIL *dest) {
+    int j, t, n = 0, m;
+    
+    // Save vertex coordinates and color for deleted triangles
+    for (j=0; j<c->numDel; j++) { 
+        
+        t = c->deleted[j].id;
+        
+        m = 3 * t;
+        
+        dest[n].x = buf_vertices[m + 0].x;
+        dest[n].y = buf_vertices[m + 0].y;
+        dest[n].z = buf_vertices[m + 0].z;
+        dest[n].a = buf_colors[m + 0].a;
+        dest[n].b = buf_colors[m + 0].b;
+        dest[n].r = buf_colors[m + 0].r;
+        dest[n].g = buf_colors[m + 0].g;
+        n++;
+        
+        dest[n].x = buf_vertices[m + 1].x;
+        dest[n].y = buf_vertices[m + 1].y;
+        dest[n].z = buf_vertices[m + 1].z;
+        dest[n].a = buf_colors[m + 1].a;
+        dest[n].b = buf_colors[m + 1].b;
+        dest[n].r = buf_colors[m + 1].r;
+        dest[n].g = buf_colors[m + 1].g;
+        n++;
+        
+        dest[n].x = buf_vertices[m + 2].x;
+        dest[n].y = buf_vertices[m + 2].y;
+        dest[n].z = buf_vertices[m + 2].z;
+        dest[n].a = buf_colors[m + 2].a;
+        dest[n].b = buf_colors[m + 2].b;
+        dest[n].r = buf_colors[m + 2].r;
+        dest[n].g = buf_colors[m + 2].g;
+        n++;
+    }
+    // Save vertex coordinates for modified triangles
+    for (j=0; j<c->numMod; j++) { 
+        
+        t = c->modified[j].id;
+        
+        m = 3 * t;
+        
+        dest[n].x = buf_vertices[m + 0].x;
+        dest[n].y = buf_vertices[m + 0].y;
+        dest[n].z = buf_vertices[m + 0].z;
+        n++;
+        
+        dest[n].x = buf_vertices[m + 1].x;
+        dest[n].y = buf_vertices[m + 1].y;
+        dest[n].z = buf_vertices[m + 1].z;
+        n++;
+        
+        dest[n].x = buf_vertices[m + 2].x;
+        dest[n].y = buf_vertices[m + 2].y;
+        dest[n].z = buf_vertices[m + 2].z;
+        n++;
+    }
+}
+
+void VMI::loadVertexBuffer(VertexIL *src, Change *c) {
+    int j, t, n = 0, m;
+    
+    // Load vertex coordinates and color for deleted triangles
+    for (j=0; j<c->numDel; j++) { 
+        
+        t = c->deleted[j].id;
+        
+        m = 3 * t;
+
+        buf_vertices[m + 0].x = src[n].x;
+        buf_vertices[m + 0].y = src[n].y;
+        buf_vertices[m + 0].z = src[n].z;
+        buf_colors[m + 0].a = src[n].a;
+        buf_colors[m + 0].b = src[n].b;
+        buf_colors[m + 0].r = src[n].r;
+        buf_colors[m + 0].g = src[n].g;
+        n++;
+
+        buf_vertices[m + 1].x = src[n].x;
+        buf_vertices[m + 1].y = src[n].y;
+        buf_vertices[m + 1].z = src[n].z;
+        buf_colors[m + 1].a = src[n].a;
+        buf_colors[m + 1].b = src[n].b;
+        buf_colors[m + 1].r = src[n].r;
+        buf_colors[m + 1].g = src[n].g;
+        n++;
+
+        buf_vertices[m + 2].x = src[n].x;
+        buf_vertices[m + 2].y = src[n].y;
+        buf_vertices[m + 2].z = src[n].z;
+        buf_colors[m + 2].a = src[n].a;
+        buf_colors[m + 2].b = src[n].b;
+        buf_colors[m + 2].r = src[n].r;
+        buf_colors[m + 2].g = src[n].g;
+        n++;
+    }
+    // Load vertex coordinates for modified triangles
+    for (j=0; j<c->numMod; j++) { 
+        
+        t = c->modified[j].id;
+        
+        m = 3 * t;
+
+        buf_vertices[m + 0].x = src[n].x;
+        buf_vertices[m + 0].y = src[n].y;
+        buf_vertices[m + 0].z = src[n].z;
+        n++;
+
+        buf_vertices[m + 1].x = src[n].x;
+        buf_vertices[m + 1].y = src[n].y;
+        buf_vertices[m + 1].z = src[n].z;
+        n++;
+
+        buf_vertices[m + 2].x = src[n].x;
+        buf_vertices[m + 2].y = src[n].y;
+        buf_vertices[m + 2].z = src[n].z;
+        n++;
+    }
+}
+
+void VMI::setupVertexArray(Mesh *mesh, Color *colors)
+{
+    int i, v1, v2, v3, n = 0;
+    GLubyte r, g, b, a;
+
+    if (buf_vertices != NULL) free(buf_vertices);
+    if (buf_colors != NULL) free(buf_colors);
+
+    buf_vertices = (Vertex_ *)malloc(mesh->numTriangles * 3 * sizeof(Vertex_));
+
+    buf_colors = (Color *)malloc(mesh->numTriangles * 3 * sizeof(Color));
+
+    if (buf_vertices == NULL) {
+        fprintf(stderr, "Error allocating memory\n");
+        exit(1);
+    }
+
+    if (buf_colors == NULL) {
+        fprintf(stderr, "Error allocating memory\n");
+        exit(1);
+    }
+
+    for (i=0; i<mesh->numTriangles; i++) {
+
+        v1= mesh->triangles[i].indices[0];
+        v2= mesh->triangles[i].indices[1];
+        v3= mesh->triangles[i].indices[2];
+        
+        if (mesh->triangles[i].enable == TRUE) {
+            
+            r = colors[i].r;
+            g = colors[i].g;
+            b = colors[i].b;
+            a = colors[i].a;
+            
+            buf_colors[n].r = r;
+            buf_colors[n].g = g;
+            buf_colors[n].b = b;
+            buf_colors[n].a = a;
+            buf_vertices[n].x = mesh->vertices[v1].x;
+            buf_vertices[n].y = mesh->vertices[v1].y;
+            buf_vertices[n].z = mesh->vertices[v1].z;
+            n++;
+            
+            buf_colors[n].r = r;
+            buf_colors[n].g = g;
+            buf_colors[n].b = b;
+            buf_colors[n].a = a;
+            buf_vertices[n].x = mesh->vertices[v2].x;
+            buf_vertices[n].y = mesh->vertices[v2].y;
+            buf_vertices[n].z = mesh->vertices[v2].z;
+            n++;
+            
+            buf_colors[n].r = r;
+            buf_colors[n].g = g;
+            buf_colors[n].b = b;
+            buf_colors[n].a = a;
+            buf_vertices[n].x = mesh->vertices[v3].x;
+            buf_vertices[n].y = mesh->vertices[v3].y;
+            buf_vertices[n].z = mesh->vertices[v3].z;
+            n++;
+        } else {
+         
+            buf_colors[n].r = 0;
+            buf_colors[n].g = 0;
+            buf_colors[n].b = 0;
+            buf_colors[n].a = 0;
+            buf_vertices[n].x = 0;
+            buf_vertices[n].y = 0;
+            buf_vertices[n].z = 0;
+            n++;
+            
+            buf_colors[n].r = 0;
+            buf_colors[n].g = 0;
+            buf_colors[n].b = 0;
+            buf_colors[n].a = 0;
+            buf_vertices[n].x = 0;
+            buf_vertices[n].y = 0;
+            buf_vertices[n].z = 0;
+            n++;
+            
+            buf_colors[n].r = 0;
+            buf_colors[n].g = 0;
+            buf_colors[n].b = 0;
+            buf_colors[n].a = 0;
+            buf_vertices[n].x = 0;
+            buf_vertices[n].y = 0;
+            buf_vertices[n].z = 0;
+            n++;
+        }
+    }
+#ifdef VERTEX_ARRAY
+    // Enable the buf_vertices vector
+    glEnableClientState(GL_COLOR_ARRAY);
+    glEnableClientState(GL_VERTEX_ARRAY);
+    
+    glColorPointer(4, GL_UNSIGNED_BYTE, 0, buf_colors);
+    glVertexPointer(3, GL_FLOAT, 0, buf_vertices);
+#endif
+
+    pbuf_colors = buf_colors;
+    pbuf_vertices = buf_vertices;
+}
+
+void VMI::setupVertexBufferObjects(Mesh *mesh, Color *colors) {
+    
+    setupVertexArray(mesh, colors);
+    
+    glBindBufferARB(GL_ARRAY_BUFFER_ARB, vertex_buf);
+    glBufferDataARB(GL_ARRAY_BUFFER_ARB, mesh->numTriangles * 3 * 3 * sizeof(float), buf_vertices, GL_STATIC_DRAW_ARB); //upload data
+
+    glVertexPointer(3, GL_FLOAT, 0,0);
+    
+    glBindBufferARB(GL_ARRAY_BUFFER_ARB, color_buf);
+    glBufferDataARB(GL_ARRAY_BUFFER_ARB, mesh->numTriangles * 3 * sizeof(Color), buf_colors, GL_STATIC_DRAW_ARB); //upload data
+    
+    glColorPointer(4, GL_UNSIGNED_BYTE, 0, 0);
+
+    // Enable the vertex array functionality:
+    glEnableClientState(GL_VERTEX_ARRAY);
+    glEnableClientState(GL_COLOR_ARRAY);
+    
+    //free(buf_vertices);
+    //buf_vertices = NULL;
+    
+    //free(buf_colors);
+    //buf_colors = NULL;
+}
+
+void VMI::updateVertexArray(Mesh *mesh, Change *c)
+{
+    int i, v1, v2, v3, t, n;
+
+    // The deleted triangles are now in background color
+    for (i=0; i<c->numDel; i++) {
+        t = c->deleted[i].id;
+
+        n = t * 3;
+
+        buf_colors[n + 0].r = 0;
+        buf_colors[n + 0].g = 0;
+        buf_colors[n + 0].b = 0;
+        buf_colors[n + 0].a = 0;
+
+        buf_colors[n + 1].r = 0;
+        buf_colors[n + 1].g = 0;
+        buf_colors[n + 1].b = 0;
+        buf_colors[n + 1].a = 0;
+
+        buf_colors[n + 2].r = 0;
+        buf_colors[n + 2].g = 0;
+        buf_colors[n + 2].b = 0;
+        buf_colors[n + 2].a = 0;
+
+        buf_vertices[n + 0].x = 0;
+        buf_vertices[n + 0].y = 0;
+        buf_vertices[n + 0].z = 0;
+
+        buf_vertices[n + 1].x = 0;
+        buf_vertices[n + 1].y = 0;
+        buf_vertices[n + 1].z = 0;
+
+        buf_vertices[n + 2].x = 0;
+        buf_vertices[n + 2].y = 0;
+        buf_vertices[n + 2].z = 0;
+    }
+
+    // Update vertex coordinates for modified triangles
+    for (i=0; i<c->numMod; i++) {
+        t = c->modified[i].id;
+
+        n = t * 3;
+
+        v1= mesh->triangles[t].indices[0];
+        v2= mesh->triangles[t].indices[1];
+        v3= mesh->triangles[t].indices[2];
+
+        buf_vertices[n + 0].x = mesh->vertices[v1].x;
+        buf_vertices[n + 0].y = mesh->vertices[v1].y;
+        buf_vertices[n + 0].z = mesh->vertices[v1].z;
+
+        buf_vertices[n + 1].x = mesh->vertices[v2].x;
+        buf_vertices[n + 1].y = mesh->vertices[v2].y;
+        buf_vertices[n + 1].z = mesh->vertices[v2].z;
+
+        buf_vertices[n + 2].x = mesh->vertices[v3].x;
+        buf_vertices[n + 2].y = mesh->vertices[v3].y;
+        buf_vertices[n + 2].z = mesh->vertices[v3].z;
+    }
+}
+
+void VMI::updateVertexBufferObjects(Mesh *mesh, Change *c) {
+    
+    glBindBufferARB(GL_ARRAY_BUFFER_ARB, vertex_buf);
+    // Map the buffer object
+	buf_vertices = ( Vertex_ *)glMapBufferARB(GL_ARRAY_BUFFER_ARB, GL_WRITE_ONLY);
+
+    glBindBufferARB(GL_ARRAY_BUFFER_ARB, color_buf);
+    // Map the buffer object
+	buf_colors = (Color   *)glMapBufferARB(GL_ARRAY_BUFFER_ARB, GL_WRITE_ONLY);
+
+    updateVertexArray(mesh, c);
+
+    // Unmap buffers
+    glBindBuffer(GL_ARRAY_BUFFER_ARB, vertex_buf);
+    if (!glUnmapBufferARB(GL_ARRAY_BUFFER_ARB)) {
+        // Handle error case
+    }
+    glBindBuffer(GL_ARRAY_BUFFER_ARB, color_buf);
+    if (!glUnmapBufferARB(GL_ARRAY_BUFFER_ARB)) {
+        // Handle error case
+    }
+}
+
+VertexIL *VMI::setupInterleave(Mesh *mesh, Color *colors)
+{
+    int i, v1, v2, v3, n = 0;
+    GLubyte r, g, b, a;
+    VertexIL *interleave = NULL;
+    
+    interleave = (VertexIL *)malloc(mesh->currentNumTriangles * 3 * sizeof(VertexIL));
+    
+    if (interleave == NULL) {
+        fprintf(stderr, "Error allocating memory\n");
+        exit(1);
+    }
+    
+    for (i=0; i<mesh->numTriangles; i++) {
+        
+        if (mesh->triangles[i].enable == TRUE) {
+            v1= mesh->triangles[i].indices[0];
+            v2= mesh->triangles[i].indices[1];
+            v3= mesh->triangles[i].indices[2];
+            
+            r = colors[i].r;
+            g = colors[i].g;
+            b = colors[i].b;
+            a = colors[i].a;
+            
+            interleave[n].tx = 0.0f;
+            interleave[n].ty = 0.0f;
+            interleave[n].r = r;
+            interleave[n].g = g;
+            interleave[n].b = b;
+            interleave[n].a = a;
+            interleave[n].x = mesh->vertices[v1].x;
+            interleave[n].y = mesh->vertices[v1].y;
+            interleave[n].z = mesh->vertices[v1].z;
+            n++;
+            
+            interleave[n].tx = 0.0f;
+            interleave[n].ty = 0.0f;
+            interleave[n].r = r;
+            interleave[n].g = g;
+            interleave[n].b = b;
+            interleave[n].a = a;
+            interleave[n].x = mesh->vertices[v2].x;
+            interleave[n].y = mesh->vertices[v2].y;
+            interleave[n].z = mesh->vertices[v2].z;
+            n++;
+            
+            interleave[n].tx = 0.0f;
+            interleave[n].ty = 0.0f;
+            interleave[n].r = r;
+            interleave[n].g = g;
+            interleave[n].b = b;
+            interleave[n].a = a;
+            interleave[n].x = mesh->vertices[v3].x;
+            interleave[n].y = mesh->vertices[v3].y;
+            interleave[n].z = mesh->vertices[v3].z;
+            n++;
+        }
+    }
+
+    return interleave;
+}
+
+void VMI::printInterleave(VertexIL *interleave, int num)
+{
+    int i;
+
+    printf("\n");
+    for (i=0; i<num * 3; i++) {
+        printf("Interleave%d (%d, %d, %d ,%d, %f, %f ,%f)\n", i,
+            interleave[i].r, interleave[i].g, interleave[i].b, interleave[i].a,
+            interleave[i].x , interleave[i].y, interleave[i].z);
+    }
+}
+
+void VMI::updateAllColorInterleave(VertexIL *interleave, int num, Color *colors)
+{
+    int i, n = 0;
+    GLubyte r, g, b, a;
+
+    for (i=1; i<=num; i++) { // Triangles start at 1
+
+        r = colors[i].r;
+        g = colors[i].g;
+        b = colors[i].b;
+        a = colors[i].a;
+
+        interleave[n].r = r;
+        interleave[n].g = g;
+        interleave[n].b = b;
+        interleave[n].a = a;
+        n++;
+
+        interleave[n].r = r;
+        interleave[n].g = g;
+        interleave[n].b = b;
+        interleave[n].a = a;
+        n++;
+
+        interleave[n].r = r;
+        interleave[n].g = g;
+        interleave[n].b = b;
+        interleave[n].a = a;
+        n++;
+    }
+}
+
+void VMI::updateColorInterleave(VertexIL *interleave, int num, Color *colors, int begin, int end)
+{
+    int i, n;
+    GLubyte r, g, b, a;
+
+    if (end > num) return;
+
+    for (i=begin; i<end; i++) {
+        
+        n = i * 3;
+
+        r = colors[i].r;
+        g = colors[i].g;
+        b = colors[i].b;
+        a = colors[i].a;
+
+        interleave[n].r = r;
+        interleave[n].g = g;
+        interleave[n].b = b;
+        interleave[n].a = a;
+
+        n++;
+        interleave[n].r = r;
+        interleave[n].g = g;
+        interleave[n].b = b;
+        interleave[n].a = a;
+
+        n++;
+        interleave[n].r = r;
+        interleave[n].g = g;
+        interleave[n].b = b;
+        interleave[n].a = a;
+    }
+}
+
+void VMI::fillColorInterleave(VertexIL *interleave, int num, int begin, int end, GLubyte color)
+{
+    int i, n;
+
+    if (end > num) return;
+
+    for (i=begin; i<end; i++) {
+        
+        n = i * 3;
+        interleave[n].r = color;
+        interleave[n].g = color;
+        interleave[n].b = color;
+        interleave[n].a = color;
+
+        n++;
+        interleave[n].r = color;
+        interleave[n].g = color;
+        interleave[n].b = color;
+        interleave[n].a = color;
+
+        n++;
+        interleave[n].r = color;
+        interleave[n].g = color;
+        interleave[n].b = color;
+        interleave[n].a = color;
+    }
+}
